"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactQuill = require("react-quill");

var _reactQuill2 = _interopRequireDefault(_reactQuill);

require("react-quill/dist/quill.snow.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * (c) Copyright Darwino Inc. 2014-2017.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


// CSS


var _quillModules = {
    toolbar: [[{ 'header': [1, 2, 3, 4, false] }], [{ 'font': [] }], [{ 'size': ['small', false, 'large'] }], ['bold', 'italic', 'underline', 'strike', 'blockquote'], [{ 'color': [] }, { 'background': [] }], [{ 'script': 'sub' }, { 'script': 'super' }], [{ 'align': [] }], [{ 'list': 'ordered' }, { 'list': 'bullet' }, { 'indent': '-1' }, { 'indent': '+1' }], ['link', 'image'], ['clean']]
};

var FieldRichText = function (_Component) {
    _inherits(FieldRichText, _Component);

    function FieldRichText() {
        _classCallCheck(this, FieldRichText);

        return _possibleConstructorReturn(this, (FieldRichText.__proto__ || Object.getPrototypeOf(FieldRichText)).apply(this, arguments));
    }

    _createClass(FieldRichText, [{
        key: "render",
        value: function render() {
            var _props = this.props,
                input = _props.input,
                meta = _props.meta,
                disabled = _props.disabled,
                readOnly = _props.readOnly,
                label = _props.label,
                props = _objectWithoutProperties(_props, ["input", "meta", "disabled", "readOnly", "label"]);

            if (readOnly) {
                return _react2.default.createElement("div", { dangerouslySetInnerHTML: { __html: input.value } });
            } else {
                // React-quill issue that sets the form dirty when the value is set
                // See: https://github.com/zenoamaro/react-quill/issues/259
                var onChange = function onChange(content, delta, source, editor) {
                    if (source !== "api") {
                        input.onChange(content);
                    }
                };
                // This generates an issue where the content gets empty when there is a click on a combobox within the toolbar */}                    
                // We only pass 'value' & 'onchange'                     
                //    onBlur={input.onBlur}


                return _react2.default.createElement(_reactQuill2.default, _extends({
                    theme: "snow"
                }, props, {
                    readOnly: disabled,
                    onChange: onChange,
                    value: input.value,
                    modules: _quillModules }));
            }
        }
    }]);

    return FieldRichText;
}(_react.Component);

exports.default = FieldRichText;