"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require("react-router-dom");

var _darwinoReact = require("@darwino/darwino-react");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * (c) Copyright Darwino Inc. 2014-2017.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


/*
 * Expected properties:
 * - databaseId (string)
 * - storeId (string)
 * - params (object)
 * - columns (array of objects (title/key))
 * - baseRoute (string)
 * 
 * Note: 'store' is a reserved prop with redux so the parameter is 'storeId', and 'databaseId' for consistency.
 */
var TableCursorList = function (_BaseCursorList) {
    _inherits(TableCursorList, _BaseCursorList);

    function TableCursorList(props) {
        _classCallCheck(this, TableCursorList);

        var _this = _possibleConstructorReturn(this, (TableCursorList.__proto__ || Object.getPrototypeOf(TableCursorList)).call(this, props));

        _this.getViewEntryCells = _this.getViewEntryCells.bind(_this);
        return _this;
    }

    _createClass(TableCursorList, [{
        key: "getViewEntries",
        value: function getViewEntries() {
            var _this2 = this;

            var columns = this.props.columns;
            var dataFetcher = this.dataFetcher;

            if (dataFetcher.isFetching()) {
                return _react2.default.createElement(
                    "tr",
                    null,
                    _react2.default.createElement(
                        "td",
                        { colSpan: columns.length },
                        "Fetching..."
                    )
                );
            }if (dataFetcher.isError()) {
                return _react2.default.createElement(
                    "tr",
                    null,
                    _react2.default.createElement(
                        "td",
                        { colSpan: columns.length },
                        _react2.default.createElement(
                            "pre",
                            null,
                            "Error: ",
                            dataFetcher.getErrorMessage() || "Unknown - please look at the log"
                        )
                    )
                );
            } else {
                if (dataFetcher.getRowCount() == 0) {
                    return _react2.default.createElement(
                        "tr",
                        null,
                        _react2.default.createElement(
                            "td",
                            { colSpan: columns.length },
                            "No entries found"
                        )
                    );
                } else {
                    return dataFetcher.getRows(0, dataFetcher.getRowCount()).map(function (entry, index) {
                        return _react2.default.createElement(
                            "tr",
                            { key: entry.unid, onClick: function onClick() {
                                    return _this2.handleRowClick(entry);
                                } },
                            _this2.getViewEntryCells(entry)
                        );
                    });
                }
            }
        }
    }, {
        key: "getViewEntryCells",
        value: function getViewEntryCells(entry) {
            var columns = this.props.columns;

            return columns.map(function (col) {
                return _react2.default.createElement(
                    "td",
                    { key: entry.__meta.unid + col.key },
                    entry[col.key]
                );
            });
        }
    }, {
        key: "getAddRowsButton",
        value: function getAddRowsButton() {
            var addRowsButtonText = this.props.addRowsButtonText;

            if (!addRowsButtonText) {
                return null;
            } else {
                return _react2.default.createElement(
                    "button",
                    { style: this.dataFetcher.hasMoreRows() ? {} : { display: 'none' }, onClick: this.loadMoreRows },
                    addRowsButtonText
                );
            }
        }
    }, {
        key: "render",
        value: function render() {
            var _props = this.props,
                viewEntries = _props.viewEntries,
                columns = _props.columns;


            return _react2.default.createElement(
                "div",
                null,
                _react2.default.createElement(
                    "div",
                    { className: "table-responsive" },
                    _react2.default.createElement(
                        "table",
                        { className: "table table-striped table-condensed table-bordered table-hover darwino-view" },
                        _react2.default.createElement(
                            "thead",
                            null,
                            _react2.default.createElement(
                                "tr",
                                null,
                                columns.map(function (col) {
                                    return _react2.default.createElement(
                                        "th",
                                        { key: col.key },
                                        col.title
                                    );
                                })
                            )
                        ),
                        _react2.default.createElement(
                            "tbody",
                            null,
                            this.getViewEntries()
                        )
                    ),
                    this.getAddRowsButton()
                )
            );
        }
    }]);

    return TableCursorList;
}(_darwinoReact.BaseCursorList);

exports.default = TableCursorList;