"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _renderStatic = require("./renderStatic");

var _reactBootstrap = require("react-bootstrap");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * (c) Copyright Darwino Inc. 2014-2017.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


/*
 * ComputedField
 */


var ComputedField = function (_Component) {
    _inherits(ComputedField, _Component);

    function ComputedField(props, context) {
        _classCallCheck(this, ComputedField);

        return _possibleConstructorReturn(this, (ComputedField.__proto__ || Object.getPrototypeOf(ComputedField)).call(this, props, context));
    }

    // Context to read from the parent - router


    _createClass(ComputedField, [{
        key: "render",
        value: function render() {
            var children = this.props.children;

            if (children) {
                var label = this.props.label;

                return _react2.default.createElement(
                    _reactBootstrap.FormGroup,
                    null,
                    label && _react2.default.createElement(
                        _reactBootstrap.ControlLabel,
                        null,
                        label
                    ),
                    _react2.default.createElement(
                        "p",
                        { className: "form-control-static" },
                        children
                    )
                );
            } else {
                var _props = this.props,
                    _label = _props.label,
                    name = _props.name,
                    format = _props.format;

                var value = void 0;
                if (name) {
                    if (!this.context.documentForm) {
                        throw new Error('ComputedField must be inside a component within a DocumentForm to get a field by name');
                    }
                    value = this.context.documentForm.getComputedValue(name);
                } else {
                    value = this.props.value;
                }
                if (format) {
                    value = format(value, name);
                }
                return _react2.default.createElement(
                    _reactBootstrap.FormGroup,
                    null,
                    _label && _react2.default.createElement(
                        _reactBootstrap.ControlLabel,
                        null,
                        _label
                    ),
                    _react2.default.createElement(
                        "p",
                        { className: "form-control-static" },
                        value !== null && value !== undefined ? value.toString() : ""
                    )
                );
            }
        }
    }]);

    return ComputedField;
}(_react.Component);

ComputedField.contextTypes = {
    documentForm: _propTypes2.default.object
};
exports.default = ComputedField;