'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBootstrap = require('react-bootstrap');

var _Dialog = require('./Dialog');

var _Dialog2 = _interopRequireDefault(_Dialog);

var _darwino = require('@darwino/darwino');

var _DocumentForm = require('./DocumentForm');

var _DocumentForm2 = _interopRequireDefault(_DocumentForm);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * (c) Copyright Darwino Inc. 2014-2017.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var renderAttachmentUrl = _darwino.Richtext.renderAttachmentUrl,
    cleanAttachmentName = _darwino.Richtext.cleanAttachmentName;


var OP_NOOP = 0;
var OP_CREATED = 1;
var OP_UPDATED = 2;
var OP_DELETED = 3;

var FieldAttachments = function (_Component) {
    _inherits(FieldAttachments, _Component);

    // Context to read from the parent - router
    function FieldAttachments(props, context) {
        _classCallCheck(this, FieldAttachments);

        var _this = _possibleConstructorReturn(this, (FieldAttachments.__proto__ || Object.getPrototypeOf(FieldAttachments)).call(this, props, context));

        if (!(context.documentForm instanceof _DocumentForm2.default)) {
            throw new Error('AttachmentTable must be inside a component within a DocumentForm');
        }
        _this.dragEnter = _this.dragEnter.bind(_this);
        _this.dragLeave = _this.dragLeave.bind(_this);
        _this.dragOver = _this.dragOver.bind(_this);
        _this.drop = _this.drop.bind(_this);
        _this.state = { dropAction: false };
        return _this;
    }

    _createClass(FieldAttachments, [{
        key: 'onUpload',
        value: function onUpload(att) {
            return !this.props.onUpload || this.props.onUpload(att);
        }
    }, {
        key: 'onDelete',
        value: function onDelete(att) {
            return !this.props.onDelete || this.props.onDelete(att);
        }
    }, {
        key: '_indexOf',
        value: function _indexOf(name) {
            var value = this.props.input.value;

            for (var i = 0; i < value.length; i++) {
                if (value[i].name == name) return i;
            }
            return -1;
        }
    }, {
        key: 'deleteFile',
        value: function deleteFile(att) {
            if (!this.onDelete(att)) {
                return;
            }
            var _props$input = this.props.input,
                onChange = _props$input.onChange,
                value = _props$input.value;

            var newAtt = [].concat(_toConsumableArray(value));
            var idx = this._indexOf(att.name);
            if (att.op == OP_CREATED) {
                newAtt.splice(idx, 1);
            } else {
                newAtt[idx] = _extends({}, att, { op: OP_DELETED });
            }
            onChange(newAtt);
        }
    }, {
        key: 'fileSelected',
        value: function fileSelected(_file) {
            var _this2 = this;

            var richTextfield = this.props.richTextfield;

            var file = _file || this.refs.upload.files[0];
            this.refs.upload.value = ""; // Reset the value

            var reader = new FileReader();
            reader.readAsDataURL(file);
            reader.onload = function () {
                var att = [].concat(_toConsumableArray(_this2.props.input.value)); // We get the new value here...
                var newAttachment = {
                    op: OP_CREATED,
                    name: (richTextfield ? richTextfield + "^^" : "") + file.name, // Create file attachment
                    length: file.size,
                    mimeType: file.type
                };
                if (!_this2.onUpload(newAttachment)) {
                    return;
                }
                // We should wait until the document is saved, performance wise
                var content = reader.result;
                newAttachment.content = content.substring(content.indexOf(',') + 1);
                var idx = _this2._indexOf(newAttachment.name);
                if (idx >= 0) {
                    att[idx] = newAttachment;
                    newAttachment.op = OP_UPDATED;
                } else {
                    att.push(newAttachment);
                }
                _this2.props.input.onChange(att);
            };
            reader.onerror = function (error) {
                alert("Error reading attachment " + file.name);
            };
        }
    }, {
        key: 'renderUpload',
        value: function renderUpload() {
            var _this3 = this;

            var _props = this.props,
                disabled = _props.disabled,
                buttonLabel = _props.buttonLabel;

            return _react2.default.createElement(
                'div',
                null,
                _react2.default.createElement('input', { ref: 'upload', type: 'file', id: 'input', onChange: function onChange(e) {
                        return _this3.fileSelected();
                    }, style: { display: "none" } }),
                _react2.default.createElement(
                    _reactBootstrap.Button,
                    { disabled: disabled, onClick: function onClick() {
                            return _this3.refs.upload.click();
                        } },
                    buttonLabel || "Choose File..."
                )
            );
        }
    }, {
        key: 'renderTable',
        value: function renderTable() {
            var _props2 = this.props,
                richTextfield = _props2.richTextfield,
                onChange = _props2.onChange,
                readOnly = _props2.readOnly;
            var _props3 = this.props,
                colName = _props3.colName,
                colLength = _props3.colLength,
                colMime = _props3.colMime,
                colDelete = _props3.colDelete;

            var attachments = this.props.input.value;
            return _react2.default.createElement(
                'table',
                { className: 'table table-condensed table-striped table-bordered table-attachments' },
                _react2.default.createElement(
                    'thead',
                    null,
                    _react2.default.createElement(
                        'tr',
                        null,
                        colName && _react2.default.createElement(
                            'th',
                            null,
                            'Name'
                        ),
                        colLength && _react2.default.createElement(
                            'th',
                            null,
                            'Size'
                        ),
                        colMime && _react2.default.createElement(
                            'th',
                            null,
                            'Type'
                        ),
                        colDelete && !readOnly && _react2.default.createElement('th', null)
                    )
                ),
                _react2.default.createElement(
                    'tbody',
                    null,
                    attachments && this.renderAttachmentRows(this.filterAttachments(attachments, richTextfield), onChange)
                )
            );
        }
    }, {
        key: 'filterAttachments',
        value: function filterAttachments(richTextfield) {
            var inline = this.props.inline;
            var attachments = this.props.input.value;
            return attachments.filter(function (att, idx) {
                if (att.op == OP_DELETED) {
                    return false;
                }
                if (richTextfield) {
                    var attName = att.name.toLowerCase();
                    if (attName.indexOf(richTextfield + "^^") == 0 // File attachement
                    || inline && attName.indexOf(richTextfield + "||") == 0) {
                        // Inline attachment
                        return false;
                    }
                }
                return true;
            });
        }
    }, {
        key: 'renderAttachmentRows',
        value: function renderAttachmentRows(attachments) {
            var _this4 = this;

            var _props4 = this.props,
                disabled = _props4.disabled,
                readOnly = _props4.readOnly;
            var _props5 = this.props,
                colName = _props5.colName,
                colLength = _props5.colLength,
                colMime = _props5.colMime,
                colDelete = _props5.colDelete;
            var _context$documentForm = this.context.documentForm.state,
                databaseId = _context$documentForm.databaseId,
                storeId = _context$documentForm.storeId,
                unid = _context$documentForm.unid;
            var onChange = this.props.onChange;

            return attachments.map(function (att) {
                return _react2.default.createElement(
                    'tr',
                    { key: att.name },
                    colName && _react2.default.createElement(
                        'td',
                        null,
                        _react2.default.createElement(
                            'a',
                            { href: att.op != OP_CREATED ? renderAttachmentUrl(databaseId, storeId, unid, att.name) : "", target: '_blank' },
                            cleanAttachmentName(att.name)
                        )
                    ),
                    colLength && _react2.default.createElement(
                        'td',
                        null,
                        att.length
                    ),
                    colMime && _react2.default.createElement(
                        'td',
                        null,
                        att.mimeType
                    ),
                    colDelete && !readOnly && _react2.default.createElement(
                        'td',
                        null,
                        _react2.default.createElement(
                            _reactBootstrap.Button,
                            { disabled: disabled, bsStyle: 'link', onClick: function onClick() {
                                    _this4.deleteFile(att);
                                } },
                            _react2.default.createElement('span', { className: 'glyphicon glyphicon-trash', 'aria-hidden': 'true' })
                        )
                    )
                );
            });
        }
    }, {
        key: 'dragEnter',
        value: function dragEnter(e) {
            e.preventDefault();
            this.setState({ dropAction: true });
        }
    }, {
        key: 'dragLeave',
        value: function dragLeave(e) {
            e.preventDefault();
            this.setState({ dropAction: false });
        }
    }, {
        key: 'dragOver',
        value: function dragOver(e) {
            e.preventDefault();e.stopPropagation();
            try {
                e.dataTransfer.dropEffect = 'copy';
            } catch (err) {}
            return false;
        }
    }, {
        key: 'drop',
        value: function drop(e) {
            var _props6 = this.props,
                disabled = _props6.disabled,
                readOnly = _props6.readOnly;

            if (!disabled && !readOnly) {
                e.stopPropagation();e.preventDefault();
                var dt = e.dataTransfer;
                var files = dt.files;
                for (var i = 0; i < files.length; i++) {
                    this.fileSelected(files[i]);
                }
            }
            this.setState({ dropAction: false });
        }
    }, {
        key: 'render',
        value: function render() {
            var _props7 = this.props,
                multiple = _props7.multiple,
                readOnly = _props7.readOnly;

            return _react2.default.createElement(
                'div',
                { onDragEnter: this.dragEnter, onDragLeave: this.dragLeave, onDragOver: this.dragOver, onDrop: this.drop },
                !readOnly && this.renderUpload(),
                this.renderTable()
            );
        }
    }]);

    return FieldAttachments;
}(_react.Component);

FieldAttachments.contextTypes = {
    documentForm: _propTypes2.default.object
};
FieldAttachments.defaultProps = {
    colName: true,
    colLength: true,
    colMime: true,
    colDelete: true
};
exports.default = FieldAttachments;