'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactBootstrap = require('react-bootstrap');

var _FieldStatic = require('./FieldStatic');

var _FieldStatic2 = _interopRequireDefault(_FieldStatic);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } } /* 
                                                                                                                                                                                                     * (c) Copyright Darwino Inc. 2014-2017.
                                                                                                                                                                                                     */


function alterValue(values, checked, val) {
    var result = [].concat(_toConsumableArray(values));
    var pos = result.indexOf(val);
    if (checked) {
        if (pos < 0) {
            result.push(val);
        }
    } else {
        if (pos >= 0) {
            result.splice(pos, 1);
        }
    }
    return result;
}

var FieldCheckbox = function (_Component) {
    _inherits(FieldCheckbox, _Component);

    function FieldCheckbox() {
        _classCallCheck(this, FieldCheckbox);

        return _possibleConstructorReturn(this, (FieldCheckbox.__proto__ || Object.getPrototypeOf(FieldCheckbox)).apply(this, arguments));
    }

    _createClass(FieldCheckbox, [{
        key: 'renderMultipleCheckbox',
        value: function renderMultipleCheckbox(values, val) {
            var _props = this.props,
                input = _props.input,
                inline = _props.inline,
                disabled = _props.disabled,
                props = _objectWithoutProperties(_props, ['input', 'inline', 'disabled']);

            return _react2.default.createElement(
                'label',
                { className: inline ? "chekbox-inline" : null, key: val.value, style: inline ? { marginRight: '1em' } : null },
                _react2.default.createElement('input', _extends({ type: 'checkbox' }, props, { checked: values.indexOf(val.value) >= 0, disabled: disabled,
                    onChange: function onChange(e) {
                        var v = alterValue(values, e.target.checked, val.value);
                        input.onChange(v);
                    },
                    onBlur: function onBlur(e) {
                        input.onBlur(values);
                    } })),
                val.label || val.value
            );
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var _props2 = this.props,
                input = _props2.input,
                multiple = _props2.multiple,
                inline = _props2.inline,
                options = _props2.options,
                checkedValue = _props2.checkedValue,
                uncheckedValue = _props2.uncheckedValue,
                disabled = _props2.disabled,
                readOnly = _props2.readOnly,
                label = _props2.label,
                props = _objectWithoutProperties(_props2, ['input', 'multiple', 'inline', 'options', 'checkedValue', 'uncheckedValue', 'disabled', 'readOnly', 'label']);

            if (readOnly) return _react2.default.createElement(_FieldStatic2.default, this.props);

            var values = input.value;
            if (multiple) {
                return _react2.default.createElement(
                    'div',
                    { className: 'checkbox' },
                    options && options.map(function (val) {
                        if (!((typeof val === 'undefined' ? 'undefined' : _typeof(val)) === "object")) val = { value: val, label: val };
                        if (inline) {
                            return _this2.renderMultipleCheckbox(values, val);
                        } else {
                            return _react2.default.createElement(
                                'div',
                                { className: 'checkbox' },
                                _this2.renderMultipleCheckbox(values, val)
                            );
                        }
                    })
                );
            } else {
                var checked = checkedValue !== undefined ? values == checkedValue : !!values;
                return _react2.default.createElement(
                    'label',
                    null,
                    _react2.default.createElement('input', _extends({ type: 'checkbox' }, props, input, { disabled: disabled, checked: checked,
                        onChange: function onChange(e) {
                            var v = e.target.checked ? checkedValue !== undefined ? checkedValue : true : uncheckedValue !== undefined ? uncheckedValue : null;
                            input.onChange(v);
                        },
                        onBlur: function onBlur(e) {
                            input.onBlur(values);
                        } })),
                    label
                );
            }
        }
    }]);

    return FieldCheckbox;
}(_react.Component);

;

exports.default = FieldCheckbox;