'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactBootstrap = require('react-bootstrap');

var _FieldStatic = require('./FieldStatic');

var _FieldStatic2 = _interopRequireDefault(_FieldStatic);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * (c) Copyright Darwino Inc. 2014-2017.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var FieldSelect = function (_Component) {
    _inherits(FieldSelect, _Component);

    function FieldSelect(props) {
        _classCallCheck(this, FieldSelect);

        var _this = _possibleConstructorReturn(this, (FieldSelect.__proto__ || Object.getPrototypeOf(FieldSelect)).call(this, props));

        _this.state = {};
        if (typeof props.options === "function") {
            var res = props.options(props);
            if (res.then) {
                _this.state.options = [];
                res.then(function (json) {
                    _this.state.options = json;
                });
            } else {
                _this.state.options = res;
            }
        }
        return _this;
    }

    _createClass(FieldSelect, [{
        key: 'render',
        value: function render() {
            // We keep the options in the list to remove them from props. But options is actually in state
            var _props = this.props,
                input = _props.input,
                disabled = _props.disabled,
                readOnly = _props.readOnly,
                type = _props.type,
                emptyOption = _props.emptyOption,
                options = _props.options,
                props = _objectWithoutProperties(_props, ['input', 'disabled', 'readOnly', 'type', 'emptyOption', 'options']);

            if (readOnly) return _react2.default.createElement(_FieldStatic2.default, _extends({}, this.props, { options: options }));

            var opt = this.state.options || options;
            return _react2.default.createElement(
                _reactBootstrap.FormControl,
                _extends({ componentClass: 'select', type: type }, props, input, { disabled: disabled }),
                emptyOption && _react2.default.createElement(
                    'option',
                    { key: '', value: '' },
                    emptyOption
                ),
                opt && opt.map(function (val, idx) {
                    if (!((typeof val === 'undefined' ? 'undefined' : _typeof(val)) === "object")) val = { value: val, label: val };
                    return _react2.default.createElement(
                        'option',
                        { key: idx + ':' + val.value, value: val.value },
                        val.label || val.value
                    );
                })
            );
        }
    }]);

    return FieldSelect;
}(_react.Component);

exports.default = FieldSelect;