/* 
 * (c) Copyright Darwino Inc. 2014-2017.
 */
import React, { Component } from "react";
import PropTypes from 'prop-types';

import { BaseCursorPage } from "@darwino/darwino-react";
import MainPageMixin from "./MainPageMixin"

import './dwo-bootstrap.css';

class FTSearchForm extends Component {
    constructor(props) {
        super(props)
        this.state = {_ftSearch: ""}
    }
    render() {
        const grid = this.props.grid
        if(grid) {
            return (
                <form className="pull-left" role="search" style={{paddingBottom: 20}}
                        onSubmit={(evt) => {evt.preventDefault(); grid.setFTSearch(this.state._ftSearch);}}>
                    <div className="btn-group">
                        <span className="glyphicon glyphicon-search ftsearch-query"
                            onClick={(evt)=> {evt.preventDefault(); grid.setFTSearch(this.state._ftSearch);}}>
                        </span>
                        <input type="search" className="form-control ftsearch-input" size="50" placeholder="Search..." name="q" 
                            value={this.state._ftSearch}
                            onChange={(evt) => this.setState({_ftSearch:evt.target.value})}/>
                        <span className="glyphicon glyphicon-remove-circle ftsearch-clear" style={this.state._ftSearch ? {} : { display: 'none' }}
                            onClick={(evt)=> {this.setState({_ftSearch:""}); grid.setFTSearch("")}}>
                        </span>
                    </div>
                </form>        
            );
        }
        return null;
    }
}

/*
 */
class CursorPage extends MainPageMixin(BaseCursorPage) {

    // Context to read from the parent
    static contextTypes = {
        router: PropTypes.object,
        dialog: PropTypes.object
    };
    
    // Overrides - mixins
    createFTSearchBar() {
        return (<FTSearchForm grid={this.getGrid()}/>)
    }    
}

export default CursorPage
