/* 
 * (c) Copyright Darwino Inc. 2014-2017.
 */
import React, {Component} from "react";
import ReactQuill from "react-quill";

// CSS
import 'react-quill/dist/quill.snow.css';

const _quillModules= {
    toolbar: [
        [{ 'header': [1, 2, 3, 4, false] }],
        [{ 'font': [] }],
        [{ 'size': ['small', false, 'large'] }],
        ['bold', 'italic', 'underline','strike', 'blockquote'],
        [{ 'color': [] }, { 'background': [] }],
        [{ 'script': 'sub'}, { 'script': 'super' }],
        [{ 'align': [] }],
        [{'list': 'ordered'}, {'list': 'bullet'}, {'indent': '-1'}, {'indent': '+1'}],
        ['link', 'image'],
        ['clean']
    ]
}

class FieldRichText extends Component {
    render() {
        const { input, meta, disabled, readOnly, label, ...props } = this.props;
        if(readOnly) {
            return (
                <div dangerouslySetInnerHTML={{__html: input.value}}></div>
            )
        } else {
            // React-quill issue that sets the form dirty when the value is set
            // See: https://github.com/zenoamaro/react-quill/issues/259
            function onChange(content,delta,source,editor) { 
                if(source!=="api") {
                    input.onChange(content)
                }
            }
            // This generates an issue where the content gets empty when there is a click on a combobox within the toolbar */}                    
            // We only pass 'value' & 'onchange'                     
            //    onBlur={input.onBlur}
            return (
                <ReactQuill
                    theme='snow'
                    {...props}
                    readOnly={disabled}
                    onChange={onChange}
                    value={input.value}
                    modules={_quillModules}>
                </ReactQuill>
            )
        }
    }
}
export default FieldRichText
