/* 
 * (c) Copyright Darwino Inc. 2014-2017.
 */
import React, {Component} from "react";
import { FormControl } from 'react-bootstrap';
import FieldStatic from './FieldStatic';

class FieldSelect extends Component {

    constructor(props) {
        super(props);
        this.state = {}
        if(typeof(props.options)==="function") {
            let res = props.options(props);
            if(res.then) {
                this.state.options = []
                res.then((json) => {
                    this.state.options = json
                })
            } else {
                this.state.options = res
            }
        }
    }

    render() {
        // We keep the options in the list to remove them from props. But options is actually in state
        const { input, disabled, readOnly, type, emptyOption, options, ...props } = this.props;
        if(readOnly) return (<FieldStatic {...this.props} options={options}/>);
        
        const opt = this.state.options || options;
        return (
            <FormControl componentClass="select" type={type} {...props} {...input} disabled={disabled}>
                { emptyOption && <option key='' value=''>{emptyOption}</option> }
                { opt && opt.map((val,idx) => {
                    if(!(typeof(val)==="object")) val = {value:val,label:val};
                    return (
                        <option key={idx+':'+val.value} value={val.value}>{val.label||val.value}</option>
                    )
                })}
            </FormControl>
        )
    }
}
export default FieldSelect
