/* 
 * (c) Copyright Darwino Inc. 2014-2017.
 */
import React, {Component} from "react";
import { Col, FormControl, FormGroup, ControlLabel } from 'react-bootstrap';
import FieldStatic from './FieldStatic';

class FieldText extends Component {
    render() {
        const { input, multiple, type, editable, separator, disabled, readOnly, ...props} = this.props;
        if(readOnly) return (<FieldStatic {...this.props}/>);
        
        let inputType = type;
        const inputReadOnly = editable!==undefined && editable

        let inputAttr = input;
        if(multiple) {
            inputAttr = {
                value: Array.isArray(input.value) ? input.value.join(separator||',') : "",
                onBlur: (e) => {
                    const a = (e.target.value || "").split(separator||',')
                    input.onBlur(a)
                },
                onChange: (e) => {
                    const a = (e.target.value || "").split(separator||',')
                    input.onChange(a)
                }
            }
            inputType = "text"
        }
        return (
            <FormControl type={type} {...props} {...inputAttr} disabled={disabled} readOnly={inputReadOnly}>
            </FormControl>
        )
    }
}
export default FieldText
