/* 
 * (c) Copyright Darwino Inc. 2014-2017.
 */
import React, {Component} from "react";
import PropTypes from 'prop-types';
import { Button, FormControl, InputGroup } from 'react-bootstrap';
import FieldStatic from './FieldStatic';
import Dialog from "./Dialog"

class FieldValuePicker extends Component {

    // Context to read from the parent - router
    static contextTypes = {
        documentForm: PropTypes.object
    };
    
    constructor(props,context) {
        super(props,context);
    }

    getDialog() {
        return this.context.documentForm.getDialog()
    }
    
    render() {
        const { input, picker, pickerTitle, multiple, separator, meta, editable, disabled, readOnly, label, ...props } = this.props;
        if(readOnly) return (<FieldStatic {...this.props}/>);

        const inputReadOnly = editable!==undefined && editable
    
        let inputAttr = input;
        if(multiple) {
            const separator = this.props.separator || ',';
            inputAttr = {
                value: Array.isArray(input.value) ? input.value.join(separator) : "",
                onBlur: (e) => {
                    const a = (e.target.value || "").split(separator)
                    input.onBlur(a)
                },
                onChange: (e) => {
                    const a = (e.target.value || "").split(separator)
                    input.onChange(a)
                }
            }
        }
        const _this=this; // not sure why this is needed
        return (
            <InputGroup>
                <FormControl type="text" {...props} {...input} disabled={disabled} inputReadOnly={!editable && !disabled}>
                </FormControl>
                <InputGroup.Button>
                    <Button onClick={()=> _this.getDialog().picker({
                            multiple,
                            title: pickerTitle,
                            value: input.value,
                            actions: [Dialog.OkAction,Dialog.CancelAction],
                            picker: picker,
                            onClose: (action,value) => {
                                if(action==Dialog.OK) {
                                    input.onChange(value)
                                }
                            }
                        })}
                        disabled={disabled}>...</Button>
                </InputGroup.Button>
            </InputGroup>
        )
    }
}

export default FieldValuePicker
