/* 
 * (c) Copyright Darwino Inc. 2014-2017.
 */
import React, {Component} from "react";
import { Col, FormGroup, ControlLabel } from 'react-bootstrap';

class InputBlock extends Component {

    render() {
        const {horizontal, inline, label, meta} = this.props
        if(horizontal) {
            return (
                <FormGroup className={meta.touched && meta.error ? 'has-error' : ''}>
                    <Col componentClass={ControlLabel} sm={2}>
                        {label}
                    </Col>
                    <Col sm={10}>
                        {this.props.children}
                    </Col>
                    {meta.touched && meta.error && <div className="error">{meta.error}</div>}
                </FormGroup>
            )
        } else {
            return (
                <FormGroup className={meta.touched && meta.error ? 'has-error' : ''}>
                    {label && <ControlLabel>{label}</ControlLabel>}
                    {inline && ' '}
                    {this.props.children}
                    {meta.touched && meta.error && <div className="error">{meta.error}</div>}
                </FormGroup>
            )
        }
    }
};

export default InputBlock
