/* 
 * (c) Copyright Darwino Inc. 2014-2017.
 */
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import Dialog from './Dialog';
import Messages from './Messages';

/*
 * Mixin implementing the features using the bootstrap library
 * see: http://justinfagnani.com/2015/12/21/real-mixins-with-javascript-classes/
 */
const MainPageMixin = (superclass) => class extends superclass {

    // Overrides - mixins
    _makeActionBar(children) {
        return (
            <div className="btn-toolbar action-bar" role="toolbar">
                {children}
            </div>
        );
    }
    getDialog() {
        return Dialog.dialog
    }

    createMessages() {
        return <Messages ref='messages' />
    }
    getMessages() {
        return this.refs.messages;
    }
};

export default MainPageMixin